# web board for hns / Board.pm
# Copyright (C) 2001 Yoichi Imai <yoichi@silver-forest.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


package Board;
use vars qw($Use_BBS, $BBSReadCGI, $BBSData, $ReadStr, $WriteStr, $LinkStr);
$Use_BBS = 0;
$BBSReadCGI = 'hnsbbs/read.cgi';
$BBSWriteCGI = 'hnsbbs/write.cgi';
$BBSData = 'hnsbbs/data/bbsdata.txt';
$ReadStr = 'Read more... (%num)';
$WriteStr = 'Post message...';
$LinkStr = '<div align="right">( %readstr | %writestr )</div>';

my %ArtcileNum;

sub read_bbsdata()
{
  return unless $Use_BBS;

  open(FH, $BBSData) || die "Can't open bbsdata file.";
  foreach (<FH>) {
    my @list = split(/\t/, $_);
    if($list[0] ne '' && $list[3] ne '' && $list[2] ne 'root') {
     $ArticleNum{$list[3]}++;
    }
  }
  close(FH);
}

sub get_linkstr($)
{
  return "" unless $Use_BBS;

  my ($daydata) = shift;
  my $num = $ArticleNum{$daydata};
  my $readstr = $ReadStr;
  my $writestr = $WriteStr;
  my $linkstr = $LinkStr;

  # readstr
  $num = 0 if ($num eq '');
  $readstr =~ s/%num/$num/g;
  if ($num != 0) {
    $readstr = qq(<a href="${BBSReadCGI}?diary=${daydata}">) . $readstr . '</a>';
  }
  # writestr
  $writestr = qq(<a href="${BBSWriteCGI}?diary=${daydata}">) . $writestr . '</a>';

  # linkstr
  $linkstr =~ s/%readstr/$readstr/g;
  $linkstr =~ s/%writestr/$writestr/g;

  return $linkstr;
}

1;
