#!/usr/local/bin/ruby -Ke

# web board for hns
# Copyright (C) 2001 Yoichi Imai <yoichi@silver-forest.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

require 'cgi'
require 'hnsbbs.rb'

cgi = CGI.new()
FORM = cgi.params
#print "Content-Type: text/plain\n\n"

def page_control(root_num)
  page = FORM['page'][0].to_i
  if root_num / ThreadsPerPage < page then
    page = 0
  end

  puts '<div align="center">'
  print '[ '
  (0..(root_num-1)/ThreadsPerPage).each do |i|
    print " / " unless i == 0
    if i == page then
      print i + 1
    else
      print %Q(<a href="#{IndexCGI}?page=#{i}">), i + 1, '</a>'
    end
  end
  puts ' ]</div>'

  return page
end

def print_article_tree(tree, key)
  return if tree[key] == nil
  
  puts ' <ul>'
  tree[key].each do |article|
    print ' <li>'
    puts article.get_subject(true)
    print_article_tree(tree, article.msgid)
    puts ' </li>'
  end
  puts ' </ul>'
end

def print_article_root(tree)
  puts '<dl>'

  list = tree['root'] || []
  list.reverse!
  
  page = page_control(list.length)
  start = page*ThreadsPerPage

  if start+ThreadsPerPage <= list.length then
    list = list[start...start+ThreadsPerPage]
  else
    list = list[start..list.length]
  end

  list.each do |article|
    puts '<dt>'
    print article.get_subject(true)
    puts '</dt>'

    puts '<dd>'
    print_article_tree(tree, article.msgid)
    puts '</dd>'
  end

  puts '</dl>'
end

hnsbbs = HnsBBS.new
hnsbbs.load
hnsbbs.create_refid_hash

HnsBBS::html_print do
  print_article_root(hnsbbs.refid_hash)
end
