#!/usr/local/bin/ruby -Ke

# web board for hns
# Copyright (C) 2001 Yoichi Imai <yoichi@silver-forest.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

require 'hnsbbs.rb'
require 'nkf'
require 'cgi'

cgi = CGI.new
FORM = cgi.params

http_host = ENV['REMOTE_ADDR']

hnsbbs = HnsBBS.new
hnsbbs.load
hnsbbs.create_msgid_hash
hnsbbs.create_refid_hash

['subject', 'name'].each do |entry|
  HnsBBS::print_error("#{entry} entry is not set.") if FORM[entry][0] == nil || FORM['subject'][0] == ''
end

['name', 'email', 'subject'].each do |field|
  next if FORM[field][0] == nil
  HnsBBS::print_error("#{field} field is too long.") if FORM[field][0].length > PostFieldMaxLen
end
HnsBBS::print_error("Too long url") if FORM['site'][0] && FORM['site'][0].length > PostURLMaxLen
HnsBBS::print_error("Too long body") if FORM['body'][0] && FORM['body'][0].length > PostBodyMaxLen
HnsBBS::print_error("Too long delete key") if FORM['key'][0] && FORM['key'][0].length > PostDeleteKeyMaxLen
HnsBBS::print_error("Invalid delete key") if FORM['key'][0] == nil || !(/[-a-zA-Z0-9_]+/ =~ FORM['key'][0]) || FORM['key'][0] == UnDeletableDeleteKey

name = html_convert(FORM['name'][0], false)
email = html_convert(FORM['email'][0], false)
site = html_convert(FORM['site'][0], false)
body = html_convert(FORM['body'][0], true)
subject = html_convert(FORM['subject'][0], false)

[name, email, site, FORM['key'][0]].each do |elem|
  HnsBBS::print_error("You can't use '|', '+' in personal information.") if /[\|\+]/ =~ elem
end
 
site = '' if site == 'http://'
refid = 'root' if (refid = FORM['refid'][0]) == nil
diary = FORM['diary'][0]

=begin
# diary
## refid -> ˲
## refidroot
### root¸ߤ -> ˲
### root¸ߤ -> rootƤ˲
# diaryʤ
## refid -> ˲
## refidroot -> Τޤ޺
=end

if diary != nil then
  if refid == 'root' then
    diary_root = nil
    hnsbbs.article_list.each do |article|
      if article.root? && article.ref_diary == diary then
	diary_root = article
      end
    end
    if diary_root == nil then
      diary_title = HnsBBS::get_diary_title(FORM['diary'][0])
      HnsBBS::print_error("Diary title getting error") if diary_title == nil
      diary_root = Article.new_with_kconv(UnDeletableDeleteKey,
					  hnsbbs.get_new_msgid,
					  'root',
					  diary,
					  Time.now,
					  "[[#{diary_title}]]")
      hnsbbs.add(diary_root)
    end
    article = Article.new_with_kconv(FORM['key'][0],
				     hnsbbs.get_new_msgid,
				     diary_root.msgid,
				     diary,
				     Time.now,
				     subject, name, email, site, http_host,body)
    hnsbbs.add(article)
  else
    article = Article.new_with_kconv(FORM['key'][0],
				     hnsbbs.get_new_msgid,
				     refid,
				     diary,
				     Time.now,
				     subject,name,email,site,http_host,body)
    hnsbbs.add(article)
  end
else
  article = Article.new_with_kconv(FORM['key'][0],
				   hnsbbs.get_new_msgid,
				   refid,
				   "",
				   Time.now,
				   subject,name,email,site,http_host,body)
  hnsbbs.add(article)
end

begin
  hnsbbs.save
rescue
  HnsBBS::print_error("񤭹ߥ顼ˤƤ¸ǤޤǤ.")
end

if FORM['cookie'][0] == "on" then
  print Cookie::set_cookie([name, email, site, FORM['key'][0]])
end

HnsBBS::html_print do
    puts "<h3>Ƥޤ</h3>"
end

  
