#!/usr/local/bin/ruby -Ke

# web board for hns
# Copyright (C) 2001 Yoichi Imai <yoichi@silver-forest.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

require 'hnsbbs.rb'
require 'cgi'
RecentView = 10

cgi = CGI.new
FORM = cgi.params

# You can use depth for style paramater of margin or padding.
# But I don't use it for style, it comes from my laziness and some browsers' problem.
def thread_print(depth, article_list, msgid_hash, refid_hash)
  return if article_list == nil

  puts '<blockquote>' if depth != 0
  article_list.each do |article|
    article.display
    thread_print(depth+1, refid_hash[article.msgid], msgid_hash, refid_hash)
  end
  puts '<blockquote>' if depth != 0
end

if FORM['thr'][0] == 'on' then
  thread_mode = true
else
  thread_mode = false
end

hnsbbs = HnsBBS.new
hnsbbs.load
hnsbbs.create_msgid_hash
hnsbbs.create_refid_hash

fit_article = nil
if FORM['diary'][0] != nil then
  hnsbbs.article_list.each do |article|
    if article.root? && article.ref_diary == FORM['diary'][0]
      fit_article = article
      thread_mode = true
    end
  end
end

if FORM['msgid'][0] != nil then
  fit_article = hnsbbs.msgid_hash[FORM['msgid'][0]]
  HnsBBS::print_error("Msgid is illegal.") if fit_article == nil
end

HnsBBS::html_print do
  article_list = hnsbbs.article_list.reverse
  if fit_article == nil then
    (0..RecentView).each do |i|
      article = article_list[i]
      next if article == nil
      next if article.root? && article.ref_diary != ''
      
      article.display(hnsbbs.msgid_hash, hnsbbs.refid_hash)
      puts '<hr>'
    end
  else
    if thread_mode == true then
      thread_print(0, [fit_article], hnsbbs.msgid_hash, hnsbbs.refid_hash)
    else
      fit_article.display(hnsbbs.msgid_hash, hnsbbs.refid_hash)
    end
  end
end

