#!/usr/local/bin/ruby -Ke

# web board for hns
# Copyright (C) 2001 Yoichi Imai <yoichi@silver-forest.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

require 'hnsbbs.rb'
require 'cgi'

cgi = CGI.new
FORM = cgi.params

hnsbbs = HnsBBS.new
hnsbbs.load
hnsbbs.create_msgid_hash
hnsbbs.create_refid_hash

new_title = ""
ref_article = nil
hidden_value = ""
diary_title = nil

if FORM['refid'][0] != nil then
  ref_article = hnsbbs.msgid_hash[FORM['refid'][0]]
  HnsBBS::print_error("Original message not found.") if ref_article == nil

  if ref_article.root? && ref_article.ref_diary != "" then # it means fake-root
    ref_article = nil
  else
    new_title = "Re: " + ref_article.title.sub(/^Re:(&nbsp;| )/, "")
    hidden_value = %Q(<input type="hidden" name="refid" value="#{ref_article.msgid}">)
    hidden_value += %Q(<input type="hidden" name="diary" value="#{ref_article.ref_diary}">)
  end

end

if FORM['diary'][0] != nil then
  diary_title = HnsBBS::get_diary_title(FORM['diary'][0])
  HnsBBS::print_error("Diary title getting error") if diary_title == ''

  new_title = "Re: #{diary_title}"
  hidden_value = %Q(<input type="hidden" name="diary" value="#{FORM['diary'][0]}">)
end

cookie = Cookie::get_cookie
if cookie != nil then
  cookie_checked = "checked"
  
  value_name = cookie[0]
  value_email = cookie[1]
  value_site = cookie[2]
  value_key = cookie[3]
end
value_site ||= "http://"

HnsBBS::html_print do
  if diary_title != nil then
    puts ("<h3>[[#{diary_title}]]ؤΥ</h3>")
  elsif ref_article != nil then
    ref_article.display
  end
  
  print <<"END_OF_FORM"
<form method="POST" action="#{PostCGI}">
#{hidden_value}
Subject: <input type="text" name="subject" value="#{new_title}"><br>
̾: <input type="text" name="name" value="#{value_name}"><br>
E-Mail: <input type="text" name="email" value="#{value_email}"><br>
Web site: <input type="text" name="site" value="#{value_site}"><br>
Delete key <input type="text" name="key" value="#{value_key}"><br>
      <input type="checkbox" name="cookie" value="on" #{cookie_checked}>CookieȤäƾ¸<br>
<textarea name="body" rows=5 cols=70>
</textarea>
<br>
<input type="submit" value="Post">
</form>
END_OF_FORM
end 
